︠9293952d-3f2e-4de5-9e80-d8b1f307f118i︠
%html
<p>As a continuation of the recent cloning of ploting methods found in mathematica. I've started a clone of RevolutionPlot3D. <br /><a title="RevolutionPlot3D" href="http://reference.wolfram.com/mathematica/ref/RevolutionPlot3D.html">http://reference.wolfram.com/mathematica/ref/RevolutionPlot3D.html</a></p>
<p>My version, however, can specify the axis of rotation of the curve, given as a line paralel to the z axis, located in the point of coordinates $(x,y)$. And also, the posibility to display the revolved curve.</p>
<p>The corresponding ticket is <a title="7889" href="http://trac.sagemath.org/sage_trac/ticket/7889">http://trac.sagemath.org/sage_trac/ticket/7889</a></p>

︡3bd02138-d1be-459e-aa1f-c2898a1a7d43︡{"html": "<p>As a continuation of the recent cloning of ploting methods found in mathematica. I've started a clone of RevolutionPlot3D. <br /><a title=\"RevolutionPlot3D\" href=\"http://reference.wolfram.com/mathematica/ref/RevolutionPlot3D.html\">http://reference.wolfram.com/mathematica/ref/RevolutionPlot3D.html</a></p>\n<p>My version, however, can specify the axis of rotation of the curve, given as a line paralel to the z axis, located in the point of coordinates $(x,y)$. And also, the posibility to display the revolved curve.</p>\n<p>The corresponding ticket is <a title=\"7889\" href=\"http://trac.sagemath.org/sage_trac/ticket/7889\">http://trac.sagemath.org/sage_trac/ticket/7889</a></p>"}︡
︠027cad63-3c80-4595-ad48-6d869b972ef3︠
def revolution_plot(cur,trange,phirange=None,axis=(0,0),showcurve=False,**kwds):
    def findvar(expr):
        try:
            vart=cur.args()[0]
        except:
            vart=var('t')
        return vart

    if phirange==None:#this if-else provides a phirange
        phi=var('phi')
        phirange=(phi,0,2*pi)
    else:
        phi=phirange[0]
        phirange=(phi,phirange[1],phirange[2])

    if str(type(cur)) == "<type 'tuple'>":#this if-else provides a vector v to be ploted
        vart=findvar(cur[0])        
        R=sqrt((cur[0]-axis[0])^2+axis[1]^2)
        v=(R*cos(phi)+axis[0],R*sin(phi)+axis[1],cur[1])
        curveplot=parametric_plot3d((cur[0],0,cur[1]),trange,thickness=2,rgbcolor=(1,0,0))
    elif str(type(cur))== "<type 'list'>":
        vart=findvar(cur[0])        
        R=sqrt((cur[0]-axis[0])^2+axis[1]^2)
        v=(R*cos(phi)+axis[0],R*sin(phi)+axis[1],cur[1])
        curveplot=parametric_plot3d((cur[0],0,cur[1]),trange,thickness=2,rgbcolor=(1,0,0))
    else:
        vart=findvar(cur)
        R=sqrt((vart-axis[0])^2+(axis[1])^2)
        v=(R*cos(phi)+axis[0],R*sin(phi)+axis[1],cur)
        curveplot=parametric_plot3d((vart,0,cur),trange,thickness=2,rgbcolor=(1,0,0))
        
    if showcurve:
        return parametric_plot3d(v,trange,phirange,**kwds)+curveplot
    return parametric_plot3d(v,trange,phirange,**kwds)
︡1d00a0db-f949-4abb-a606-5162b7c24e63︡︡
︠fec7ddf0-db25-472f-9d35-f4e30b3cfbd2i︠
%html
<p>Let's clone the examples in the link above</p>

︡81bff86f-519f-47f9-972b-762b62c7db95︡{"html": "<p>Let's clone the examples in the link above</p>"}︡
︠8f6866b4-7886-4a27-b94a-076ee73c49c6︠
var('t,fi')
torus=(2+cos(2*pi*t),sin(2*pi*t))
pot=t^4-t^2
k=2

def g(t):
    if t>0.5:
        return t
    else:
        return t^2
︡619e472d-0993-49f1-af04-5d84f29b67a2︡︡
︠ed00aca9-350d-4628-8acb-c3712056f260︠
plot=revolution_plot(pot,(t,0,1),showcurve=True,opacity=0.5).show(aspect_ratio=(1,1,3))
︡3c3f8e17-d069-48d5-8e67-5d7e39da4899︡︡
︠81f3bb90-caa4-4cda-bdd1-6b512f0fa120︠
revolution_plot(torus,(t,0,1),showcurve=True,opacity=0.5).show(aspect_ratio=(1,1,1))
︡d82d66c4-e146-46dc-a016-cddf455a60d2︡︡
︠6a944188-564c-4832-8aaf-d0b8d1656085i︠
%html
<p>Now let's revolve those curves around different axes and see what happens.</p>

︡6d03c38d-c4e4-49b5-86d3-6fb4dc74204f︡{"html": "<p>Now let's revolve those curves around different axes and see what happens.</p>"}︡
︠30c1e19a-db7c-471f-a036-1203d8a7990a︠
plot=revolution_plot(pot,(t,0,1),axis=(1,0),showcurve=True,opacity=0.5).show(aspect_ratio=(1,1,3))
︡c33bfb90-62d8-4a23-acea-ae296e808343︡︡
︠5d89ba30-9373-4d48-ae20-4dfc455a6c5e︠
plot=revolution_plot(pot,(t,0,1),axis=(0.5,0.5),showcurve=True,opacity=0.5).show(aspect_ratio=(1,1,3))
︡2c27f4e4-df5f-4701-b82e-700fb52978f1︡︡
︠3902a14b-6cce-4885-b547-24b627313c93︠
revolution_plot(torus,(t,0,1),axis=(1.5,1),showcurve=True,opacity=0.5).show(aspect_ratio=(1,1,1))
︡70644536-4391-4a80-a5ea-5fe89baea831︡︡
︠ff859064-a386-45e8-b94e-64d16b65c766︠
revolution_plot(torus,(t,0,1),axis=(2,1),showcurve=True,opacity=0.5).show(aspect_ratio=(1,1,1))
︡e88c757a-1f2d-427f-a20d-7f9b33a3eb01︡︡
︠9cfe5539-7d9f-4dd2-9b2c-2c1e3c7eedb3i︠
%html
<p>Non-symbolical functions have been troublesome. I would appreciate help to support themwhich I can't explain... <br />Mathematica also supports revolutions of 3d curves, that will require further thinking.</p>
<p>Now another example shamelessly stolen from Mathematica:</p>

︡9ba93066-6f58-4dd8-a2ca-6a7b66ab48de︡{"html": "<p>Non-symbolical functions have been troublesome. I would appreciate help to support themwhich I can't explain... <br />Mathematica also supports revolutions of 3d curves, that will require further thinking.</p>\n<p>Now another example shamelessly stolen from Mathematica:</p>"}︡
︠844a02dc-176d-4074-b538-f827c0a90509︠
revolution_plot((sin(t)+sin(9*t)/5,cos(t)+cos(9*t)/5),(t,0,pi),(fi,0,pi),plotpoints=[150,150]).show(aspect_ratio=(1,1,1),frame=False)
︡fe431326-e621-4f00-92c1-364494247e31︡︡
